varying vec2		v_texCoord;

uniform sampler2D	s_texture;
uniform	vec4		u_scale;

void main()
{
	vec2	size = u_scale.xy * u_scale.zw;
	vec2	scaled = v_texCoord * u_scale.xy;
	vec2	floatPart  = fract( scaled );
	vec2	texCoord = v_texCoord;
	
	vec2	texelSize = 1.0/size;
	vec4	midPixel = texture2D( s_texture, texCoord );
	vec4	leftPixel = texture2D( s_texture, texCoord - vec2(texelSize.x, 0.0) );
	vec4	rightPixel = texture2D( s_texture, texCoord + vec2(texelSize.x, 0.0));
	
	vec4 	pixel = midPixel * 0.7 + (leftPixel + rightPixel) * 0.3;
	
	float	fBright = max(max(pixel.r, pixel.g), pixel.b) * 0.65 + 0.35;
	
	float fScale = min( (1.0 - floatPart.y / fBright)*2.0, 1.0);
	fScale *= 1.05;
	fScale *= 1.0 - floor(floatPart.x* 1.25) * 0.05;
	
	gl_FragColor = clamp(vec4(pixel.xyz * fScale, 1.0), 0.0, 1.0);
}