//precision mediump float;
varying vec2 v_texCoord;
varying vec4 v_Colour;
uniform sampler2D s_texture;

const float smoothing = 1.0/8.0;
const float kCentre = 0.5;//485;

void main()
{
/*
	float distance = texture2D( s_texture, v_texCoord ).a;
	
	float alpha = smoothstep(kCentre - smoothing, kCentre + smoothing, distance);
	
//	vec4 newcol = vec4(1.0f, alpha, alpha, 0.4f);
//	gl_FragColor = newcol * v_Colour;//vec4(v_Colour.rgb, alpha);

	gl_FragColor = vec4(v_Colour.rgb, alpha * v_Colour.a);
*/
	const float kGamma = 1.0/2.2;
	const float smoothness = 64.0;


	// retrieve signed distance
	float sdf = texture( s_texture, v_texCoord.xy ).r;

	// perform adaptive anti-aliasing of the edges
	float w = clamp( smoothness * (abs(dFdx(v_texCoord.x)) + abs(dFdy(v_texCoord.y))), 0.0, 0.5);
	float a = smoothstep(0.5-w, 0.5+w, sdf);

	// gamma correction for linear attenuation
	a = pow(a, kGamma);

	// final color
	//oColor.rgb = vColor.rgb;
	//oColor.a = vColor.a * a;
	gl_FragColor = vec4(v_Colour.rgb, a * v_Colour.a);
};
